<CFSETTING ENABLECFOUTPUTONLY="YES">

<!---// initialize cfDebug Variables (passed to calling script) //--->
<CFPARAM NAME="Caller.cfDebug.WindowNo" DEFAULT="0">
<CFPARAM NAME="Caller.cfDebug.ExeTime" DEFAULT="0">
<CFPARAM NAME="Caller.cfDebug.ProcessedScript" DEFAULT="NO">
<CFPARAM NAME="Caller.cfDebug.ScopeList" DEFAULT="">
<!---// a variable Caller.cfDebug.#ScopeName#Scope will be
      defined for each scope found in the calling template //--->

<!---// initialize command line attribute //--->
<CFPARAM NAME="Attributes.NAME" DEFAULT="cfDebugWindow">
<CFPARAM NAME="Attributes.TURNON" DEFAULT="VARIABLES,URL,FORM,COOKIE,CLIENT,SESSION,APPLICATION,CGI,SERVER">
<CFPARAM NAME="Attributes.CGI" DEFAULT="">
<CFPARAM NAME="Attributes.WIDTH" DEFAULT="400">
<CFPARAM NAME="Attributes.HEIGHT" DEFAULT="400">

<!---// initialize local CF_DEBUG variables //--->
<CFSET CustomScopes = Ucase(Attributes.TURNON)>
<CFSET txtOutput = ""> 
<CFSET cfDebugVersion = "3.0">
<!---// get CF app server version number. this number should be a four digit number
        the code below ensures that it is indeed a four-digit number //--->
<CFSET cfVersion = Left(ListChangeDelims(SERVER.ColdFusion.ProductVersion,"",", ") & "0000", 4)>

<!---// set execution time since last time var cfDebug.ExeTime was set 
        ColdFusion 4+ execution time is based in milliseconds 
				ColdFusion 3 execution time is based in seconds                 //--->
<CFIF (cfVersion GTE 4000) AND (Caller.cfDebug.ExeTime GT 0)>
	<CFSET ExeTime = GetTickCount() - Caller.cfDebug.ExeTime>
<CFELSEIF Caller.cfDebug.ExeTime GT 0>
	<CFSET ExeTime = DateDiff("s", Caller.cfDebug.ExeTime, Now())>
<CFELSE>
	<CFSET ExeTime = -1>
</CFIF>

<!---// set the number of calls to CF_DEBUG //--->
<CFSET Caller.cfDebug.WindowNo = IncrementValue(CALLER.cfDebug.WindowNo)>
<!---// set the JavaScript window name //--->
<CFSET Attributes.NAME = Attributes.NAME & CALLER.cfDebug.WindowNo>

<!---// get all CFSET Variables: 
        concept by Jonathan Doklovic  - jdmonkey@fuseware.com 
        edited and re-coded by Dan G. Switzer, II - dswitzer@pengoworks.com  //--->
<CFIF NOT Caller.cfDebug.ProcessedScript>
	<CFSET beginStr = "<cfset ">
	<CFSET endStr = "=">
	<CFSET beginStrLen = Len(beginStr)>

	<!---// read in current script file //--->	
	<CFFILE ACTION="READ" FILE="#CGI.CF_TEMPLATE_PATH#" VARIABLE="Source">
	
	<!---// set the starting position for when you begin parsing for the next string //--->
	<CFSET iPosition = 1>
	<CFLOOP CONDITION="iPosition NEQ 0">
		<!---// find the beginning portion of the string you're looking for //--->
		<CFSET findStartingStr = FindNoCase(beginStr,Source,iPosition)> 
			<CFIF findStartingStr IS 0>
				<CFBREAK>
			</CFIF>
		<!---// find the ending portion of the string //--->
		<CFSET findEndingStr = FindNoCase(endStr,Source,findStartingStr + beginStrLen)>
			<CFIF findEndingStr IS 0>
				<CFBREAK>
			</CFIF>
		<!---// grab the data between the beginning and ending strings //--->
		<CFSET cfSetVariable = Mid(Source,findStartingStr+beginStrLen,(findEndingStr-(findStartingStr + beginStrLen)))>

		<!---// if the length is > 0, then add the variable to the list //--->
		<CFIF Len(cfSetVariable) GT 0>
			<!---// if the variable reference in the <CFSET> tag is not scoped,
			        add it to the "Variables" scope //--->
			<CFIF ListLen(cfSetVariable,".") IS 1>
				<CFSET cfSetVariable = "Variables." & cfSetVariable>
			</CFIF>
			<!---// define the "CallingScope" variable name, this holds a list of
			        all the variables within a given scope //--->
			<CFSET strCallingScope = "Caller.cfDebug." & Lcase(GetToken(cfSetVariable, 1, ".")) & "Scope">
			<!---// if the current scope type is not in the list of scopes, then add it //--->
			<CFIF ListFindNoCase(Caller.cfDebug.ScopeList, GetToken(cfSetVariable, 1, ".")) IS 0>
				<CFSET Caller.cfDebug.ScopeList = ListAppend(Caller.cfDebug.ScopeList,Ucase(GetToken(cfSetVariable, 1, ".")))>
			</CFIF>
			<!---// initialize the calling scope list //--->
			<CFPARAM NAME="#strCallingScope#" DEFAULT="">
			<!---// if the current variable being set is not in the list of varibles for that scope, then add it //--->
			<CFIF ListFindNoCase(Evaluate(strCallingScope), GetToken(cfSetVariable, 2, ".")) IS 0>
				<CFSET tempVar = SetVariable("#strCallingScope#", ListAppend(Evaluate(strCallingScope), GetToken(cfSetVariable, 2, ".")))>
			</CFIF>
		</CFIF>
		
		<!---// reset the new starting position for when you begin parsing for the next string //--->
		<CFSET iPosition = findEndingStr + Len(endStr)>
	</CFLOOP>
	<!---// set the marker stating that the calling script has been processed //--->
	<CFSET Caller.cfDebug.ProcessedScript = "YES">
</CFIF>
<!---// end get all CFSET Variables //--->

<!---// loop through the scope list initializing all of the variables defined within each scope //--->
<CFLOOP INDEX="strScope" LIST="#Caller.cfDebug.ScopeList#" DELIMITERS=",">
	<CFSET value = Evaluate("Caller.cfDebug.#Lcase(strScope)#Scope")>
	<CFPARAM NAME="Attributes.#strScope#" DEFAULT="#value#">
</CFLOOP>

<!---// get all URL scoped Variables //--->
<CFIF Len(Trim(Caller.CGI.Query_String)) GT 0>
	<CFPARAM NAME="Attributes.URL" DEFAULT="">
	<CFLOOP INDEX="strVar" LIST="#CGI.Query_String#" DELIMITERS="&">
		<CFSET Attributes.URL = ListAppend(Attributes.URL, GetToken(strVar,1,"="), ",")>
	</CFLOOP>
</CFIF>

<!---// get all FORM scoped Variables //--->
<CFIF IsDefined("Caller.FORM.fieldnames")>
	<CFPARAM NAME="Attributes.FORM" DEFAULT="#Caller.FORM.fieldnames#">
</CFIF>

<!---// get all CLIENT scoped variables //--->
<CFIF IsDefined("Client.CFID") AND IsDefined("Client.CFTOKEN") AND NOT IsDefined("Attributes.CLIENT")>
	<CFSET Attributes.CLIENT = "CFID,CFToken,URLToken,HitCount,TimeCreated,LastVisit">
	<CFSET Attributes.CLIENT = ListAppend(Attributes.CLIENT, GetClientVariablesList(), ",")>
</CFIF>

<!---// get all SESSION scoped variables (CF4 *ONLY*)//--->
<CFIF (cfVersion GTE 4000) AND NOT IsDefined("Attributes.SESSION")>
	<CFLOOP COLLECTION="#session#" ITEM="thisKey">
		<CFPARAM NAME="Attributes.SESSION" DEFAULT="">
		<CFIF IsSimpleValue(session[thisKey])>
			<CFSET Attributes.SESSION = ListAppend(Attributes.SESSION, thisKey, ",")>
		</CFIF>
	</CFLOOP>
</CFIF>

<!---// get all APPLICATION scoped variables (CF4 *ONLY*)//--->
<CFIF (cfVersion GTE 4000) AND NOT IsDefined("Attributes.APPLICATION")>
	<CFLOOP COLLECTION="#application#" ITEM="thisKey">
		<CFPARAM NAME="Attributes.APPLICATION" DEFAULT="">
		<CFIF IsSimpleValue(application[thisKey])>
			<CFSET Attributes.APPLICATION = ListAppend(Attributes.APPLICATION, thisKey, ",")>
		</CFIF>
	</CFLOOP>
</CFIF>

<!---// get all CGI scoped variables //--->
<CFSET Attributes.CGI="ALL_HTTP
AUTH_TYPE
AUTH_USER
CF_TEMPLATE_PATH
CONTENT_LENGTH
CONTENT_TYPE
GATEWAY_INTERFACE
HTTP_ACCEPT
HTTP_ACCEPT_LANGUAGE
HTTP_COOKIE
HTTP_CONNECTION
HTTP_HOST
HTTP_REFERER
HTTP_UA_CPU
HTTP_UA_COLOR
HTTP_UA_OS
HTTP_UA_PIXELS
HTTP_USER_AGENT
PATH_INFO
PATH_TRANSLATED
QUERY_STRING
REMOTE_ADDR
REMOTE_HOST
REMOTE_IDENT
REMOTE_USER
REQUEST_BODY
REQUEST_METHOD
SCRIPT_NAME
SERVER_PORT
SERVER_PROTOCOL
SERVER_SOFTWARE
WEB_SERVER_API">
<!---// the above CGI variables where delimited by a carriage return to make it easier
        to read. to get the variable back to the correct delimited format, we use the
				code below //--->
<CFSET Attributes.CGI = ListChangeDelims(Attributes.CGI, ",", "#Chr(10)##Chr(13)#")>

<!---// if the execution time is greater then "-1", then display the execution time
        if the execuation time is less then zero, then this is the first time
				CF_Debug has been called //--->
<CFIF ExeTime GT -1>
	<!---// when using CF4, execution time is in milliseconds, otherwise it's in seconds //--->
	<CFIF cfVersion GTE 4000>
		<CFSET ExeTime = ExeTime & " milliseconds">
	<CFELSEIF ExeTime IS 0>
		<CFSET ExeTime = "less than 0 seconds">
	<CFELSE>
		<CFSET ExeTime = ExeTime & " seconds">
	</CFIF>
	<!---// store the execution time in the txtOutput variable for output //--->
	<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<P><FONT COLOR=""##CC0033""><B>Execution Time:</B></FONT> #ExeTime#</P>');#Chr(10)#">
</CFIF>

<!---// remove all spaces from the string //--->
<CFSET CustomScopes = Replace(CustomScopes, " ", ",", "ALL")>
<!---// Get all SCOPED variables //--->
<CFLOOP INDEX="strScope" LIST="#CustomScopes#" DELIMITERS=",">
	<!---// make sure the current scope exists //--->
	<CFIF IsDefined("Attributes.#strScope#")>
		<!---// create the heading that is to be outputted to the screen //--->
		<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<P><FONT SIZE=""2""><B><I>#strScope# Scope</I></B></FONT><BR>');#Chr(10)#">
		<!---// initialize the current list of variables to output to the screen  //--->
		<CFSET lstVariables = Evaluate("Attributes.#strScope#")>
		<!---// loop through the list of variables in order to prepare them to be displayed on the screen  //--->
		<CFLOOP INDEX="strVariable" LIST="#lstVariables#">
			<!---// write the current variable name to the string for outputting //--->
			<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<FONT COLOR=""##CC0033""><B>#strScope#.#Trim(strVariable)#:</B></FONT> ">
			<!---// if it's value is defined, display it, otherwise display "%undefined%" //--->
			<CFIF IsDefined("Caller.#strScope#.#Trim(strVariable)#")>
				<CFSET txtOutput = txtOutput & Evaluate("Caller.#strScope#.#Trim(strVariable)#")>
			<CFELSE>
				<CFSET txtOutput = txtOutput & "%undefined%">
			</CFIF>
			<!---// close the string to be displayed //--->
			<CFSET txtOutput = txtOutput & "<BR>');#Chr(10)#">
		</CFLOOP>
		<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('</P>');#Chr(10)#">
	</CFIF>
</CFLOOP>


<!---// get all ColdFusion server variables //--->
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<HR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<P><FONT SIZE=""2""><B><I>ColdFusion Server Variables</I></B></FONT><BR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<FONT COLOR=""##CC0033""><B>SERVER.ColdFusion.ProductName:</B></FONT> #SERVER.ColdFusion.ProductName#<BR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<FONT COLOR=""##CC0033""><B>SERVER.ColdFusion.ProductVersion:</B></FONT> #SERVER.ColdFusion.ProductVersion#<BR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<FONT COLOR=""##CC0033""><B>SERVER.ColdFusion.ProductLevel:</B></FONT> #SERVER.ColdFusion.ProductLevel#<BR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<FONT COLOR=""##CC0033""><B>SERVER.OS.Name:</B></FONT> #SERVER.OS.Name#<BR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<FONT COLOR=""##CC0033""><B>SERVER.OS.AdditionalInformation:</B></FONT> #SERVER.OS.AdditionalInformation#<BR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<FONT COLOR=""##CC0033""><B>SERVER.OS.Version:</B></FONT> #SERVER.OS.Version#<BR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<FONT COLOR=""##CC0033""><B>SERVER.OS.BuildNumber:</B></FONT> #SERVER.OS.BuildNumber#<BR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('</P>');#Chr(10)#">

<!---// get all CF_Debug information //--->
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<HR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('<P><FONT COLOR=""##CC0033""><B>SERVER.OS.BuildNumber:</B></FONT> #SERVER.OS.BuildNumber#<BR>');#Chr(10)#">
<CFSET txtOutput = txtOutput & "#Attributes.NAME#.document.write('</P>');#Chr(10)#">

<!---// parse through the text to be displayed and write all the required JavaScript escape codes //---> 
<CFSET txtOutput = REReplace(txtOutput, "\\", "\\\", "ALL")>
<CFSET txtOutput = REReplace(txtOutput, "'", "\'", "ALL")>
<CFSET txtOutput = REReplace(txtOutput, ".write\(\\'", ".write('", "ALL")>
<CFSET txtOutput = REReplace(txtOutput, "\\'\);#Chr(10)#", "');#Chr(10)#", "ALL")>

<!---// push all of the JavaScript code generated between the <HEAD></HEAD> tags of the document //--->
<CFHTMLHEAD TEXT="<SCRIPT LANGUAGE=""JavaScript""><!--//
#Attributes.NAME# = window.open('', '#Attributes.NAME#','height=#Attributes.HEIGHT#,width=#Attributes.WIDTH#,top=#Evaluate(Caller.cfDebug.WindowNo * 25)#,screenY=#Evaluate(Caller.cfDebug.WindowNo * 25)#,left=#Evaluate(Caller.cfDebug.WindowNo * 15)#,screenX=#Evaluate(Caller.cfDebug.WindowNo * 15)#,toolbar=no,scrollbars=yes,resizable=yes');
#Attributes.NAME#.document.open();
#Attributes.NAME#.document.write('<HTML>');
#Attributes.NAME#.document.write('<HEAD><BASEFONT FACE=""Arial, Verdana, Helvetica, sans-serif"" SIZE=""1""><TITLE>CF_DEBUG v#cfDebugVersion# [#Attributes.NAME#]</TITLE></HEAD>');
#Attributes.NAME#.document.write('<BODY BGCOLOR=""##FFFFFF"" LINK=""##CC0033"" VLINK=""##CC0033""><FONT FACE=""Arial, Verdana, Helvetica, sans-serif"">');
#Attributes.NAME#.document.write('<P><CENTER><FONT SIZE=""3""><B><U>ColdFusion Variables</U></B></FONT></CENTER></P>');
#txtOutput#
#Attributes.NAME#.document.write('<CENTER><FORM><INPUT TYPE=""BUTTON"" VALUE=""Close"" onClick=""self.close()""></FORM>');
#Attributes.NAME#.document.write('CF_Debug written by <A HREF=""mailto:dswitzer@pengoworks.com"">Dan G. Switzer, II</A><BR>Distributed by <A HREF=""http://www.pengoworks.com/"" TARGET=""_new"">PengoWorks.com</A></CENTER>');
#Attributes.NAME#.document.write('</FONT></BODY></HTML>');
#Attributes.NAME#.document.close();
//--></SCRIPT>">


<!---// if the current CF app server is above version 4, then set the execution time 
        to current tick, otherwise you're forced to use seconds //--->
<CFIF cfVersion GTE 4000>
	<CFSET Caller.cfDebug.ExeTime = GetTickCount()>
<CFELSE>
	<CFSET Caller.cfDebug.ExeTime = Now()>
</CFIF>


<CFSETTING ENABLECFOUTPUTONLY="NO">
